package gonganxitong

import (
	"shylinux.com/x/ice"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/community/src/gonganxitong/model"
)

type qrcode struct {
	Tables
	apply       apply
	portal      Portal
	order       string `data:"501"`
	role        string `data:"leader"`
	applyQRCode string `name:"applyQRCode" help:"邀请码" role:"void"`
	placeQRCode string `name:"placeQRCode" help:"场景码" role:"void"`
}

func (s qrcode) ApplyQRCode(m *ice.Message, arg ...string) {
	m.Option(ice.MSG_FG, "blue")
	s.info(m, arg[0], "apply")
	s.EchoQRCode(m, arg[0], s.Prefix(m, s.apply)).Echo("请让申请人扫码，然后审批权限")
}
func (s qrcode) PlaceQRCode(m *ice.Message, arg ...string) {
	s.info(m, arg[0], "portal")
	s.EchoQRCode(m, arg[0]).Echo(kit.JoinWord(m.Append(model.CITY_NAME), m.Append(s.Keys(s.Street, model.NAME)), m.Append(s.Keys(s.Place, model.NAME))))
}
func (s qrcode) List(m *ice.Message, arg ...string) {
	s.PlaceQRCode(m, arg[0])
}

func init() { ice.TeamCtxCmd(qrcode{Tables: newTables()}) }

func (s Table) EchoQRCode(m *ice.Message, arg ...string) *ice.Message {
	m.EchoQRCode(s.Link(m, arg...)).Echo("<img class='avatar' src='%s'/>", m.Resource(kit.Select(ice.Info.NodeIcon, m.Option(model.AUTH_AVATAR))))
	return m
}
func (s qrcode) info(m *ice.Message, place_uid, cmd string) *ice.Message {
	m.Cmdy(s.Prefix(m, s.portal), s.portal.PlaceList, m.Option(model.USER_UID), place_uid)
	m.Option(model.AUTH_AVATAR, m.Append(model.AUTH_AVATAR))
	m.Cut(model.CITY_NAME, s.Keys(s.Street, model.NAME), s.Keys(s.Place, model.NAME))
	m.Push(model.QRCODE_TYPE, cmd).Action(s.ApplyQRCode, s.PlaceQRCode)
	return m
}
